const defInterval = 1.0 ' 1 second
const defForce = 1.5 	' 1.5 units of mass
const defTime = 5 * 60 	' 5 minutes
const defGravity = 1.0  ' A factor of 1

type levelT
	lname as string * 20
	ltime as integer
	ldtInterval as double
	ldtforce as double
	lgravfactor as double
end type

dim as string filename
dim as integer f
dim level as levelT

filename = ltrim$(rtrim$(command$))

print

f = freefile
open "levels/" + filename + ".lev" for binary as #f

	if lof(f) > 0 then

		get #f, , level

		print "Editing Existing Level: "

	else

		level.lname = filename
		level.ltime = defTime
		level.ldtInterval = defInterval
		level.ldtforce = defForce
		level.lgravfactor = defGravity
		print "New Level, Defaults chosen: "
	
	end if

close #f

print "Name", " "+level.lname
print "Time Limit", level.ltime
print "DT Interval", level.ldtInterval
print "DT Force", level.ldtforce
print "Gravity", level.lgravfactor

print 
print "Edit (CTRL+C to cancel at any time)"
print "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-="
print

dim as string in
dim as integer ini
dim as double ind

print "Enter name: (Blank too leave current)"
line input ": ", in
in = ltrim$(rtrim$(in))

if len(in) then
	level.lname = in
end if

print
print "Enter time limit in seconds: (Black too leave current, 0 for default)"
line input ": ", in
in = ltrim$(rtrim$(in))

if len(in) then
	ini = val(in)
	if ini = 0 then
		level.ltime = defTime
	else
		level.ltime = ini
	end if
end if


print
print "Enter DT Interval: (Black too leave current, 0 for default)"
line input ": ", in
in = ltrim$(rtrim$(in))

if len(in) then
	ind = val(in)
	if ind = 0 then
		level.ldtinterval = defInterval
	else
		level.ldtinterval = ind
	end if
end if

print
print "Enter DT Force: (Black too leave current, 0 for default)"
line input ": ", in
in = ltrim$(rtrim$(in))

if len(in) then
	ind = val(in)
	if ind = 0 then
		level.ldtforce = defForce
	else
		level.ldtforce = ind
	end if
end if

print
print "Enter Gravity Factor: (Black too leave current, Default is 1)"
line input ": ", in
in = ltrim$(rtrim$(in))

if len(in) then
	ind = val(in)
	'if ind = 0 then
	'	level.lgravfactor = defGravity
	'else
		level.lgravfactor = ind
	'end if
end if

kill filename + ".lev"
f = freefile
open "levels/" + filename + ".lev" for binary as #f
	put #f, , level
close #f

print
print "Done. Saved."
