
	defint a-z

	const xres = 320
	const yres = 240

	common shared backBuffer as integer ptr
	'dim shared backBuffer as integer ptr

        #define BLENDPIXEL(sx, sy, r, g, b) _
                pix = point(sx, sy, backBuffer): _
                pr = pix shr 16: _
                pg = (pix shr 8) and &hff: _
                pb = pix and &hff: _
                sr = (pr * popacity) + ro: _
                sg = (pg * popacity) + go: _
                sb = (pb * popacity) + bo: _
                pset backBuffer, (sx, sy), (sr shl 16) or (sg shl 8) or sb

        #define BLENDPIXELOUT(sx, sy, r, g, b) _
                pix = point(sx, sy, backBuffer): _
                pr = pix shr 16: _
                pg = (pix shr 8) and &hff: _
                pb = pix and &hff: _
                sr = (pr * opopacity) + oro: _
                sg = (pg * opopacity) + ogo: _
                sb = (pb * opopacity) + obo: _
                pset backBuffer, (sx, sy), (sr shl 16) or (sg shl 8) or sb


function clipLine ( byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, _
                    byval rx1 as integer, byval ry1 as integer, byval rx2 as integer, byval ry2 as integer, _
                    byref cx1 as integer, byref cy1 as integer, _
                    byref cx2 as integer, byref cy2 as integer ) as integer    
                    
    ' A form of the Cohen-Sutherland Algorithm
    
    ' note: had problems with macros getting confused, had to switch to constants
    
    ' (y - y1) = (x - x1)m
    
    ' p1:
    ' y = (x - x1)m + y1
    ' x = (y - y1)/m + x1

    ' p2:
    ' y = (x - x2)m2 + y2
    ' x = (y - y2)/m2 + x2

    dim fx1 as double = x1' + 0.5
    dim fy1 as double = y1' + 0.5
    dim fx2 as double = x2' + 0.5
    dim fy2 as double = y2' + 0.5
    dim fcx1 as double, fcy1 as double
    dim fcx2 as double, fcy2 as double
    dim m as double = (fy2 - fy1) / (fx2 - fx1)
    dim rm as double = 1 / m
    dim m2 as double = (fy1 - fy2) / (fx1 - fx2)
    dim rm2 as double = 1 / m2

    ' clip rectange x1,y1 must be less than x2,y2
    
    const CC_C = &h0
    
    const CC_N = &h01
    const CC_S = &h02
    const CC_E = &h04
    const CC_W = &h08
    
    const CC_NE = CC_N or CC_E
    const CC_NW = CC_N or CC_W
    const CC_SE = CC_S or CC_E
    const CC_SW = CC_S or CC_W
    
    p1c = CC_C
    p2c = CC_C
    
    if x1 < rx1 then
        
        p1c = CC_W
        
    elseif x1 > rx2 then
        
        p1c = CC_E
        
    end if
        
    if y1 < ry1 then
        
        p1c = p1c or CC_N
        
    elseif y1 > ry2 then
        
        p1c = p1c or CC_S
        
    end if

    if x2 < rx1 then
        
        p2c = CC_W
        
    elseif x2 > rx2 then
        
        p2c = CC_E
        
    end if
        
    if y2 < ry1 then
        
        p2c or= CC_N
        
    elseif y2 > ry2 then
        
        p2c or= CC_S
        
    end if
    
    if p1c = CC_C and p2c = CC_C then
        
        cx1 = x1
        cy1 = y1
        cx2 = x2
        cy2 = y2
        
        return 1
        
    end if
    
    if (p1c and p2c) then return 0
    
    if p1c = CC_C then
        
        fcx1 = fx1
        fcy1 = fy1
        
    elseif p1c = CC_N then
        
        fcx1 = (ry1 - fy1)*rm + fx1
        fcy1 = ry1
        
    elseif p1c = CC_S then

        fcx1 = (ry2 - fy1)*rm + fx1
        fcy1 = ry2
        
    elseif p1c = CC_E then
        
        fcx1 = rx2
        fcy1 = (rx2 - fx1)*m + fy1
        
    elseif p1c = CC_W then
        
        fcx1 = rx1
        fcy1 = (rx1 - fx1)*m + fy1
        
    elseif p1c = CC_NE then
        
        fcx1 = (ry1 - fy1)*rm + fx1
        fcy1 = ry1
        
        if (fcx1 < rx1) or (fcx1 > rx2) then

            fcx1 = rx2
            fcy1 = (rx2 - fx1)*m + fy1

        end if
    
    elseif p1c = CC_NW then
    
        fcx1 = (ry1 - fy1)*rm + fx1
        fcy1 = ry1
        
        if (fcx1 < rx1) or (fcx1 > rx2) then

            fcx1 = rx1
            fcy1 = (rx1 - fx1)*m + fy1

        end if
    
    elseif p1c = CC_SE then
        
        fcx1 = (ry2 - fy1)*rm + fx1
        fcy1 = ry2
        
        if (fcx1 < rx1) or (fcx1 > rx2) then

            fcx1 = rx2
            fcy1 = (rx2 - fx1)*m + fy1

        end if

    elseif p1c = CC_SW then
        
        fcx1 = (ry2 - fy1)*rm + fx1
        fcy1 = ry2
        
        if (fcx1 < rx1) or (fcx1 > rx2) then

            fcx1 = rx1
            fcy1 = (rx1 - fx1)*m + fy1

        end if
    
    end if

    if p2c = CC_C then
        
        fcx2 = fx2
        fcy2 = fy2
        
    elseif p2c = CC_N then
        
        fcx2 = (ry1 - fy2)*rm2 + fx2
        fcy2 = ry1
        
    elseif p2c = CC_S then
        
        fcx2 = (ry2 - fy2)*rm2 + fx2
        fcy2 = ry2
        
    elseif p2c = CC_E then
        
        fcx2 = rx2
        fcy2 = (rx2 - fx2)*m2 + fy2
        
    elseif p2c = CC_W then
        
        fcx2 = rx1
        fcy2 = (rx1 - fx2)*m2 + fy2
        
    elseif p2c = CC_NE then
        
        fcx2 = (ry1 - fy2)*rm2 + fx2
        fcy2 = ry1
        
        if (fcx2 < rx1) or (fcx2 > rx2) then

            fcx2 = rx2
            fcy2 = (rx2 - fx2)*m2 + fy2

        end if

    elseif p2c = CC_NW then
    
        fcx2 = (ry1 - fy2)*rm2 + fx2
        fcy2 = ry1
        
        if (fcx2 < rx1) or (fcx2 > rx2) then

            fcx2 = rx1
            fcy2 = (rx1 - fx2)*m2 + fy2

        end if

    elseif p2c = CC_SE then
        
        fcx2 = (ry2 - fy2)*rm2 + fx2
        fcy2 = ry2
        
        if (fcx2 < rx1) or (fcx2 > rx2) then

            fcx2 = rx2
            fcy2 = (rx2 - fx2)*m2 + fy2

        end if

    elseif p2c = CC_SW then
        
        fcx2 = (ry2 - fy2)*rm2 + fx2
        fcy2 = ry2
        
        if (fcx2 < rx1) or (fcx2 > rx2) then

            fcx2 = rx1
            fcy2 = (rx1 - fx2)*m2 + fy2

        end if

    end if
    
    if (fcx1 < rx1) or (fcx1 > rx2) or _
       (fcx2 < rx1) or (fcx2 > rx2) or _
       (fcy1 < ry1) or (fcy1 > ry2) or _
       (fcy2 < ry1) or (fcy2 > ry2) then return 0
    
    cx1 = fix(fcx1)
    cy1 = fix(fcy1)
    cx2 = fix(fcx2)
    cy2 = fix(fcy2)
    
    return 1
    
end function

	sub drawlazer ( byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, _
                    byval inr as integer, byval ing as integer, byval inb as integer, _
                    byval outr as integer, byval outg as integer, byval outb as integer, _
                    byval opacity as double, byval oopacity as double )
                
        dim popacity as double = 1.0 - opacity
        dim opopacity as double = 1.0 - oopacity
        
        ro = (inr * opacity)
        go = (ing * opacity)
        bo = (inb * opacity)

        oro = (outr * oopacity)
        ogo = (outg * oopacity)
        obo = (outb * oopacity)

        if clipline(x1, y1, x2, y2, 0, 0, xres-1, yres-1, x1, y1, x2, y2) then
                
            dx = x2 - x1
            dy = y2 - y1
            
            if dx >= 0 then
                
                xinc = 1
                
            else
                
                dx = -dx
                xinc = -1
                
            end if
        
            if dy >= 0 then
                
                yinc = 1
                
            else
                
                dy = -dy
                yinc = -1
                
            end if
            
            if dx > dy then
                
                dx2 = dx shl 1
                dy2 = dy shl 1
                errort = dx2 - (dx2 - dy)
                y = y1
                
                for x = x1 to x2 step xinc
                    
                    errort += dy2
                    
                    if errort >= dx2 then
                        
                        errort -= dx2
                        y += yinc
                        
                    end if
                    
                    BLENDPIXELOUT(x, y-1, outr, outg, outb)
                    BLENDPIXEL(x, y, inr, ing, inb)
                    BLENDPIXELOUT(x, y+1, outr, outg, outb)
    
                next x
                
            elseif dx = dy then
                
                y = y1
                for x = x1 to x2 step xinc
                    
                    y = y + yinc
                    
                    BLENDPIXELOUT(x-1, y, outr, outg, outb)
                    BLENDPIXEL(x, y, inr, ing, inb)
                    BLENDPIXELOUT(x+1, y, outr, outg, outb)
                    
                next x
                    
            elseif dy >= dx then
        
                dy2 = dy shl 1
                dx2 = dx shl 1
                errort = dy2 - (dy2 - dx)
                x = x1
                
                for y = y1 to y2 step yinc
                    
                    errort += dx2
                    
                    if errort >= dy2 then
                        
                        errort -= dy2
                        x += xinc
                        
                    end if
                    
                    BLENDPIXELOUT(x-1, y, outr, outg, outb)
                    BLENDPIXEL(x, y, inr, ing, inb)
                    BLENDPIXELOUT(x+1, y, outr, outg, outb)
                    
                next y
        
            end if
            
        end if
                
    end sub
